;*****************************************************************************;
;*                                                                           *;
;*				     c64.h			       	     *;
;*                                                                           *;
;*		        C64 system specific definitions			     *;
;*                                                                           *;
;*                                                                           *;
;*                                                                           *;
;* (C) 1998-2002 Ullrich von Bassewitz                                       *;
;*               Wacholderweg 14                                             *;
;*               D-70597 Stuttgart                                           *;
;* EMail:        uz@musoftware.de                                            *;
;*                                                                           *;
;*                                                                           *;
;* This software is provided 'as-is', without any expressed or implied       *;
;* warranty.  In no event will the authors be held liable for any damages    *;
;* arising from the use of this software.                                    *;
;*                                                                           *;
;* Permission is granted to anyone to use this software for any purpose,     *;
;* including commercial applications, and to alter it and redistribute it    *;
;* freely, subject to the following restrictions:                            *;
;*                                                                           *;
;* 1. The origin of this software must not be misrepresented; you must not   *;
;*    claim that you wrote the original software. If you use this software   *;
;*    in a product, an acknowledgment in the product documentation would be  *;
;*    appreciated but is not required.                                       *;
;* 2. Altered source versions must be plainly marked as such, and must not   *;
;*    be misrepresented as being the original software.                      *;
;* 3. This notice may not be removed or altered from any source              *;
;*    distribution.                                                          *;
;*                                                                           *;
;*****************************************************************************;

;* Additional key defines *;
.DEFINE CH_F1			133
.DEFINE CH_F2			137
.DEFINE CH_F3			134
.DEFINE CH_F4			138
.DEFINE CH_F5			135
.DEFINE CH_F6			139
.DEFINE CH_F7			136
.DEFINE CH_F8			140



;* Color defines *;
.DEFINE COLOR_BLACK  	       	0
.DEFINE COLOR_WHITE  	       	1
.DEFINE COLOR_RED    	       	2
.DEFINE COLOR_CYAN      	3
.DEFINE COLOR_VIOLET 	       	4
.DEFINE COLOR_GREEN  	       	5
.DEFINE COLOR_BLUE   	       	6
.DEFINE COLOR_YELLOW 		7
.DEFINE COLOR_ORANGE 	       	8
.DEFINE COLOR_BROWN  	       	9
.DEFINE COLOR_LIGHTRED       	$A
.DEFINE COLOR_GRAY1  	       	$B
.DEFINE COLOR_GRAY2  	       	$C
.DEFINE COLOR_LIGHTGREEN     	$D
.DEFINE COLOR_LIGHTBLUE      	$E
.DEFINE COLOR_GRAY3  	       	$F



;* Define hardware *;

.DEFINE _VIC    	$D000

.DEFINE	_SID	$D400

.DEFINE _CIA1	$DC00
.DEFINE _CIA2	$DD00



;* Define special memory areas *;
.DEFINE COLOR_RAM	$D800



;* End of c64.i *;




