.INCLUDE "c64.inc"
.INCLUDE "c64.i"
.INCLUDE "cbm.i"
.INCLUDE "opcodes.i"
.INCLUDE "zpvar.i"
.INCLUDE "stack.i"
.INCLUDE "stdscr.i"
.INCLUDE "16bit.i"

.IMPORT inczp,addzp,subzp
.IMPORT initsqr,nextsqr,sqrt16
.IMPORT waitretrace

.DEFINE CHARSET $4000
.DEFINE DD00VAL $c6
.DEFINE D018VAL $20
.DEFINE D011VAL $5b
.DEFINE D020VAL $00
.DEFINE D021VAL $0b
.DEFINE D022VAL $08
.DEFINE D023VAL $05
.DEFINE D024VAL $07
.DEFINE SCRN $4800
.DEFINE CYCTAB $4100
.DEFINE COLTAB $4300

.DEFINE SPDCADR $5400

.DEFINE CYCX 0
.DEFINE CYCY 0
.DEFINE CYCH 12
.DEFINE CYCW 20
.DEFINE CYCADR CYCY*SCRW+CYCX+CYCW-1+SCRN
.DEFINE CYCADR2 CYCH*SCRW+CYCADR

z	= 2;global pointers
z2 = 4

localzp = $20;z_localzp

.ADDR *+2
	sei
	jsr initpart

	ldx #CYCW
	ldy #CYCH
	lda #<(SPDCADR)
	pha
	lda #>(SPDCADR)
	pha
	lda #<(CYCADR2-SCRW)
	pha
	lda #>(CYCADR2-SCRW)
	pha
	lda #<(CYCADR2)
	pha
	lda #>(CYCADR2)
	jsr prepcycling
	pla
	pla
	pla
	pla
	pla
	jmp makecycling
	rts
;-------------------------------------
.PROC makecycling
	jsr waitretrace
	inc $d020
cycpos = *+1
	ldx #0
	jsr SPDCADR
	dec $d020

	inc cycpos
	
	jmp makecycling
.ENDPROC
;-------------------------------------
.PROC prepcycling
xpos = localzp
ypos = localzp+1
ysqrcnt = localzp+2
ysqr = localzp+3
xsize = localzp+5

	stx xpos
	stx xsize
	sty ypos

	sta cycdest1+1
	tay
	and #3
	ora #>COLOR_RAM
	sta coldest1+1
	
	tsx
	lda STACK+3,x
	sta cycdest1
	sta coldest1
	clc
	adc #1
	sta cycdest3
	sta coldest3
	tya
	adc #0
	sta cycdest3+1
	and #3
	ora #>COLOR_RAM
	sta coldest3+1

	lda STACK+5,x
	sta cycdest2
	sta coldest2
	clc
	adc #1
	sta cycdest4
	sta coldest4
	lda STACK+4,x
	sta cycdest2+1
	pha
	adc #0
	sta cycdest4+1
	and #3
	ora #>COLOR_RAM
	sta coldest4+1
	pla
	and #3
	ora #>COLOR_RAM
	sta coldest2+1

	lda STACK+6,x
	sta z+1
	lda STACK+7,x
	sta z

	sec
	jsr initsqr
	stx ysqr
	sty ysqr+1
	sta ysqrcnt

yloop:
	ldx xsize
	stx xpos

	sec
	jsr initsqr
xloop:
	txa
	clc
	adc ysqr
	pha
	tya
	adc ysqr+1
	tax
	pla
	jsr sqrt16
	sta cycphase
	sta colphase
	
	ldy #spdce-spdc-1
:	lda spdc,y
	sta (z),y
	dey
	bpl :-

	dec16 cycdest1
	dec16 cycdest2
	dec16 coldest1
	dec16 coldest2
	inc16 cycdest3
	inc16 cycdest4
	inc16 coldest3
	inc16 coldest4

	lda #spdce-spdc
	ldx #z
	jsr addzp

	jsr nextsqr
	dec xpos
	bne xloop

	lda cycdest1
	clc
	adc #SCRW+(CYCW)
	sta cycdest1
	sta coldest1
	bcc :+
	inc cycdest1+1
	inc coldest1+1
:
	lda cycdest3
	clc
	adc #SCRW-(CYCW)
	sta cycdest3
	sta coldest3
	bcc :+
	inc cycdest3+1
	inc coldest3+1
:
	lda cycdest2
	sec
	sbc #SCRW-(CYCW)
	sta cycdest2
	sta coldest2
	bcs :+
	dec cycdest2+1
	dec coldest2+1
:
	lda cycdest4
	sec
	sbc #SCRW+(CYCW)
	sta cycdest4
	sta coldest4
	bcs :+
	dec cycdest4+1
	dec coldest4+1
:
	ldx ysqr
	ldy ysqr+1
	lda ysqrcnt
	clc
	jsr initsqr
	jsr nextsqr
	stx ysqr
	sty ysqr+1
	sta ysqrcnt

	dec ypos
	beq :+
	jmp yloop
:
	ldy #0
	lda #RTSCODE
	sta (z),y
	rts
spdc:	
cycphase=*+1
			lda CYCTAB,x
cycdest1=*+1
			sta $ffff
cycdest2=*+1
			sta $ffff
cycdest3=*+1
			sta $ffff
cycdest4=*+1
			sta $ffff
colphase=*+1
			lda COLTAB,x
coldest1=*+1
			sta $ffff
coldest2=*+1
			sta $ffff
coldest3=*+1
			sta $ffff
coldest4=*+1
			sta $ffff
spdce:
.ENDPROC
;-------------------------------------
.PROC initpart
	lda #DD00VAL
	sta $dd00
	lda #D018VAL
	sta $d018
	lda #D011VAL
	sta $d011
	lda #D020VAL
	sta $d020
	lda #D021VAL
	sta $d021
	lda #D022VAL
	sta $d022
	lda #D023VAL
	sta $d023
	lda #D024VAL
	sta $d024

	rts
.ENDPROC
